<?php

if ( !( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {
    die( 'Direct Access to this location is not allowed.' );
}

function cbAgoraDateFormat()
{
    global $_CB_database;

    static $dateformat; //static to avoid many queries to database
    
    if(empty($dateformat)) {
	    $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_date_format'";
	    $_CB_database->setQuery( $query );
	    $row = $_CB_database->loadAssoc();
	    $dateformat = $row['conf_value'];
    }
    return $dateformat;    
}

function cbAgoraTimeFormat()
{
    global $_CB_database;
    
    static $timeformat; //static to avoid many queries to database
    
    if(empty($timeformat)) {
	    $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_time_format'";
	    $_CB_database->setQuery( $query );
	    $row = $_CB_database->loadAssoc();
	    $timeformat = $row['conf_value'];
    }
    return $timeformat;    
}

function cbAgoraGMaps()
{
    global $_CB_database;
    static $gmaps;
    
    if(empty($gmaps)) {
        $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_um_key'";
        $_CB_database->setQuery( $query );
        $row = $_CB_database->loadAssoc();
        $gmaps['key'] = $row['conf_value'];
        
        $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_um_default_zoom'";
        $_CB_database->setQuery( $query );
        $row = $_CB_database->loadAssoc();
        $gmaps['def_zoom'] = $row['conf_value'];
        
        $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_um_default_lat'";
        $_CB_database->setQuery( $query );
        $row = $_CB_database->loadAssoc();
        $gmaps['def_lat'] = $row['conf_value'];
        
        $query = "SELECT * FROM #__agora_config WHERE `conf_name`= 'o_um_default_lng'";
        $_CB_database->setQuery( $query );
        $row = $_CB_database->loadAssoc();
        $gmaps['def_lng'] = $row['conf_value'];
    }
    return $gmaps;
}

function cbAgoraGetUser($josUserId)
{
    global $_CB_database;
    
    static $agoraUser; //static to avoid many queries to database
    
    if(empty($agoraUser)) { 
        $query = 'SELECT * FROM #__agora_users WHERE `jos_id`='.$josUserId;
        $_CB_database->setQuery( $query );      
        $agoraUser = $_CB_database->loadAssoc();
    }
    
    /*foreach($agoraUser as &$value) {
        if( empty($value) )
            $value = "Unknown";
    }*/
    
    return $agoraUser;
}

function cbAgoraMessagingSection($user)
{
    $return = null;
    $return .= "<p>Jabber:\t" . $user['jabber'] . "</p>\n";
    $return .= "<p>ICQ:\t" . $user['icq'] . "</p>\n";
    $return .= "<p>MSN:\t" . $user['msn'] . "</p>\n";
    $return .= "<p>AOL IM:\t" . $user['aim'] . "</p>\n";
    $return .= "<p>Yahoo:\t" . $user['yahoo'] . "</p>\n";
    $return .= "<p>XFire:\t" . $user['xfire'] . "</p>\n";
    $return .= "<p>Skype:\t" . $user['skype'] . "</p>\n";    
    return $return;        
}

function cbAgoraFilter($string)
{
    global $_CB_database;
    return $_CB_database->Quote(JFilterInput::clean($string));
}

function cbAgoraGetPosts($josUserId, $limit = 10)
{
    global $_CB_database;
    
    static $posts; //static to avoid many queries to database
	
    if(empty($posts)) { 
		$query =
				'SELECT #__agora_topics.id, #__agora_topics.poster, #__agora_topics.subject, #__agora_topics.descrip_t, 
					#__agora_topics.posted, #__agora_topics.last_post, #__agora_topics.last_post_id, #__agora_topics.last_poster, 
					#__agora_topics.num_views, #__agora_topics.num_replies, #__agora_topics.closed, #__agora_topics.sticky, 
					#__agora_topics.moved_to, #__agora_topics.forum_id, #__agora_topics.question, #__agora_topics.yes, #__agora_topics.`no` , 
					#__agora_topics.icon_topic, #__agora_forums.forum_name, #__agora_forums.forum_desc
				FROM #__agora_topics
					INNER JOIN #__agora_posts ON #__agora_topics.id = #__agora_posts.topic_id
					INNER JOIN #__agora_forums ON #__agora_forums.id = #__agora_topics.forum_id 
					INNER JOIN #__agora_users ON #__agora_posts.poster_id = #__agora_users.id 
				WHERE #__agora_users.jos_id=' . (int)$josUserId . '
				GROUP BY topic_id ORDER BY  last_post DESC LIMIT '. $limit;
		
		$_CB_database->setQuery($query);
		$posts = $_CB_database->loadAssocList();

    }	
	
    return $posts;
}

function cbAgoraGetConf($conf_name)
{
    global $_CB_database;
    $conf = '';
	$query = 'SELECT conf_value FROM #__agora_config WHERE conf_name=\'' . $conf_name . '\'';
	$_CB_database->setQuery($query);
	$conf = $_CB_database->loadResult();
	return $conf;
}

function cbAgoraGetSubscribedTopics($josUserId, $limit = 10)
{
    global $_CB_database;
    
    static $sub_topics; //static to avoid many queries to database
	
    if(empty($sub_topics)) { 
		$query =
				'SELECT 
					t.id, t.subject, t.poster, t.num_replies
				FROM #__agora_topics AS t
					INNER JOIN #__agora_subscriptions AS s ON s.topic_id = t.id
					INNER JOIN #__agora_users AS u ON s.user_id = u.id
				WHERE u.jos_id= ' . (int)$josUserId . ' LIMIT ' . $limit ;
		
		$_CB_database->setQuery($query);
		$sub_topics = $_CB_database->loadAssocList();

    }	
	
    return $sub_topics;	

}


function cbAgoraGetSubscribedForums($josUserId, $limit = 10)
{
    global $_CB_database;
    
    static $sub_forums; //static to avoid many queries to database
	
    if(empty($sub_forums)) { 
		$query =
				'SELECT 
					forums.id, forums.forum_name, forums.num_posts, forums.num_topics,forums.forum_desc
				FROM #__agora_forums AS forums
					INNER JOIN #__agora_subscriptions AS s ON s.forum_id = forums.id
					INNER JOIN #__agora_users AS u ON s.user_id = u.id 
				WHERE u.jos_id= ' . (int)$josUserId . ' LIMIT ' . $limit ;
		
		$_CB_database->setQuery($query);
		$sub_forums = $_CB_database->loadAssocList();

    }	
	
    return $sub_forums;	

}

function cbAgoraMonthFormat($date, $dateFormat) {

	$months_full = array('January','February','March','April','May','June','July','August','September','October','November','December');
	$months_short = array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	
	if ((strpos($dateFormat, 'M') !== false) || (strpos($dateFormat, 'F') !== false)){
		if (strpos($dateFormat, 'M') !== false) {
			$months = $months_short;
		}
		if (strpos($dateFormat, 'F') !== false) {
			$months = $months_full;
		}
		foreach($months as $month) {
			$date = str_replace($month, JText::_('CB_'.strtoupper($month)), $date);
		}
	}
	
	return $date;
}

?>
